#include "MElemento.h"


namespace MElemento {

  // FUNCIONES AUXILIARES
   
  void LeeStringBinario(ifstream &fich, string &s);
  void EscribeStringBinario(ofstream &fich, string s);
   
  /* Potasio 4 1 K 19 39.09 */    
  void escribirElemento(TElemento elem) 
  {
     cout << elem.nombre  << ESPACIO;
     cout << elem.periodo << ESPACIO;
     cout << elem.grupo   << ESPACIO;
     cout << elem.simbolo << ESPACIO;
     cout << elem.numero  << ESPACIO;
     cout << elem.masa    << endl;
  }
  /*
  Radio
  7 2 Ra 88 226.02
  */
  void leerElementoFichero(ifstream &fich, TElemento &elem)
  {
     getline(fich,elem.nombre,ENTER);
     fich >> elem.periodo;
     fich >> elem.grupo;
     fich >> elem.simbolo;
     fich >> elem.numero;
     fich >> elem.masa;
     fich.ignore();
  }     

  
  void leerElementoFicheroBIN (ifstream &fich, TElemento &elemento)
  {
       LeeStringBinario(fich, elemento.nombre);
       fich.read((char *)&elemento.periodo, sizeof(TNatural));
       fich.read((char *)&elemento.grupo, sizeof(TNatural));
       LeeStringBinario(fich, elemento.simbolo);       
       fich.read((char *)&elemento.numero, sizeof(TNatural));         
       fich.read((char *)&elemento.masa, sizeof(TNatural));
   }
  
 
  void escribirElementoFicheroBIN (ofstream &fich, TElemento elemento)
  {
       EscribeStringBinario(fich, elemento.nombre);
       fich.write((char *)&elemento.periodo, sizeof(TNatural));
       fich.write((char *)&elemento.grupo, sizeof(TNatural));
       EscribeStringBinario(fich, elemento.simbolo);       
       fich.write((char *)&elemento.numero, sizeof(TNatural));         
       fich.write((char *)&elemento.masa, sizeof(TNatural));
   }
    // FUNCIONES AUXILIARES
   
   void LeeStringBinario(ifstream &fich, string &s) 
   { 
      int i,tam; 
      char car; 
      fich.read((char *)&tam, sizeof(int)); 
      s = ""; 
      if (fich.eof())
      {
         tam=0;
      }
      for(i=0;i<tam;++i) 
      { 
         fich.read((char *)&car, sizeof(char)); 
         s+=car; // Concatenamos el carcter ledo al string 
      } 
   }
   
   void EscribeStringBinario(ofstream &fich, string s) 
   { 
        int i,tam; 
        char car; 
        tam = s.length(); 
        fich.write((char *)&tam, sizeof(int)); 
        for(i=0;i<tam;++i) 
        { 
           car = s[i]; 
           fich.write((char *)&car, sizeof(char)); 
        } 
   }

}
