#ifndef _MElemento_h_	//fichero MElemento.h
#define _MElemento_h_

#include <iostream>
#include <fstream>

using namespace std;

namespace MElemento {
  
  
  const char ENTER = '\n';
  const char SEPARADOR = '#';
  const char ESPACIO = ' ';
  
  typedef unsigned int TNatural;
  
  struct TElemento {   
     string nombre;
     TNatural periodo;
     TNatural grupo;
     string simbolo;
     TNatural numero;
     double masa;    
  };
  
  /* Escribe los datos de un elemento por pantalla.*/
  void escribirElemento(TElemento elem);  
  
  /* Lee los datos de un elemento desde un fichero de texto, donde fich  es el descriptor del mismo.*/
  void leerElementoFichero(ifstream &fich, TElemento &elem);

  /* Lee el contenido del fichero con nombre nombre_fichero y lo almacena en una tabla.*/
  void leerElementoFicheroBIN (ifstream &fich, TElemento &elemento); 
  
  /* Vuelca al fichero con nombre nombre_fichero el contenido de una tabla.*/
  void escribirElementoFicheroBIN (ofstream &fich, TElemento elemento);
  
}
#endif
